#ifndef hash_h
#define hash_h

typedef struct
	{
	void ** list;
	int num;
	} HashItemList;

typedef struct
	{
	HashItemList * list;
	int num;
	} HashTable;


void hash_create(HashTable * list, int size);
void hash_insert(HashTable * list, void * item, int hash);
void * hash_get(HashTable * list, void * item, int hash, int (*compare)(void *, void *));
void hash_destroy(HashTable * list, void (*freefunc)(void *));
int hash_string(char * s);
int hash_buffer(char * s, int l);

#endif
